import cv2
# VideoCaptureのインスタンスを作成（追加）
cap = cv2.VideoCapture(0)

# マスク画像を読み込み
img_mask = cv2.imread('mask.png', cv2.IMREAD_UNCHANGED)

# Webカメラのフレームごとに処理（追加）
while True:
  ret, img_original = cap.read()
  img_original = cv2.flip(img_original, 1)

  # 顔を認識
  cascade = cv2.CascadeClassifier('haarcascade_frontalface_default.xml')
  img_original_gray = cv2.cvtColor(img_original, cv2.COLOR_BGR2GRAY)
  faces = cascade.detectMultiScale(img_original_gray, scaleFactor=1.5)

  # それぞれの顔について
  for (f_x, f_y, f_w, f_h) in faces:

    # 顔領域を長方形で表示
    cv2.rectangle(img_original, (f_x, f_y), (f_x + f_w, f_y + f_h), (0, 0, 255), thickness=2)

    #マスクの開始位置とサイズを取得
    m_x = f_x
    m_w = f_w
    m_h = int(f_h * 0.55)
    m_y = f_y + f_h - m_h

    #マスクを拡大・縮小
    img_mask_scaled = cv2.resize(img_mask, (m_w, m_h))

    # フレーム画像の上にマスク画像を重ねる
    img_mask_alpha = img_mask_scaled[:, :, 3:] / 255
    img_original[m_y:m_y + m_h, m_x:m_x + m_w] = \
    img_original[m_y:m_y + m_h, m_x:m_x + m_w] * \
    (1 - img_mask_alpha) + img_mask_scaled[:, :, :3] * img_mask_alpha

  # 結果の表示
  cv2.imshow('mask', img_original)

  # キーボード入力を1ミリ秒待ち、押されたらウインドウを閉じる（変更）
  k = cv2.waitKey(1)
  if k != -1:
    cv2.destroyAllWindows()
    cap.release()
    break
